'''\
jsonserver product

patches the zpublisher to provide json-rpc
'''

from zLOG import LOG, INFO, WARNING
from Globals import ImageFile

misc_ = {'_dummy': 'marker'}

def initialize(context):
    import jsonrpc

    # do the patching
    jsonrpc.patch_HTTPRequest()

    # add the files to the url space jsonrpc.
    # Then the files are mapped to the /misc_/jsonserver space,
    # and the import from HTML will be possible as:
    #	<script type="text/javascript" src="/misc_/jsonserver/jsolait.js"></script>
    
    try:
        misc_['jsolait.js'] = ImageFile('jsolait/jsolait.js', globals())
        misc_['crypto.js'] = ImageFile('jsolait/lib/crypto.js', globals())
        misc_['dom.js'] = ImageFile('jsolait/lib/dom.js', globals())
        misc_['forms.js'] = ImageFile('jsolait/lib/forms.js', globals())
        misc_['iter.js'] = ImageFile('jsolait/lib/iter.js', globals())
        misc_['jsonrpc.js'] = ImageFile('jsolait/lib/jsonrpc.js', globals())
        misc_['lang.js'] = ImageFile('jsolait/lib/lang.js', globals())
        misc_['sets.js'] = ImageFile('jsolait/lib/sets.js', globals())
        misc_['testing.js'] = ImageFile('jsolait/lib/testing.js', globals())
        misc_['urllib.js'] = ImageFile('jsolait/lib/urllib.js', globals())
        misc_['xml.js'] = ImageFile('jsolait/lib/xml.js', globals())
        misc_['xmlrpc.js'] = ImageFile('jsolait/lib/xmlrpc.js', globals())
    except (IOError, OSError):
        LOG('jsonserver', WARNING, 'Failed to map the jsolait client side' +
            ' javascript files. Maybe you want to go to the Products/jsonserver/jsolait' +
            ' subdirectory, and run install_jsolait.py to import them?')
