#! /usr/bin/python
##############################################################################
#
# Copyright (c) 2005 Jim Washington and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
# jsolait installer
#
#
# jsolait is available on the net, licensed LGPL. When you run this
# script, you will download, unzip, and make appropriate changes to
# the jsolait library to make it usable with jsonserver.

import os, md5, urllib
from textwrap import dedent

#get the current, working version of jsolait
#this one (a beta of 1.1) works as of now (3 Jun 05)
loc = 'http://jsolait.net/download/'

#filename = 'jsolait.1.0.zip'
#md5sum = 'ebc94219a9d0d58fcc8e2eae76872027'
filename = 'jsolait.2005-09-14.zip'
md5sum = '293e102fe5c092f33c9905efb4fa2a6f'

fileurl = loc + filename

#Assure the folders are there.
for directory in ['src','doc','lib','libws']:
    if not os.path.exists(directory):
        os.mkdir(directory)

zippedfile = os.path.join('src',filename)

#get file unless it is already there
if not os.path.exists(zippedfile):
    print "retrieving %s" % fileurl
    urllib.urlretrieve(fileurl,zippedfile)
else:
    print "%s exists; reprocessing. " % zippedfile
    print "to retrieve again, delete or rename %s." % zippedfile

#check file signature
print "checking md5"
filedata = file(zippedfile,'r').read()
check = md5.new(filedata).hexdigest()
if not check == md5sum:
    raise ValueError('md5 sums do not match')

#got the file; now, unzip it.

import zipfile

print "unzipping %s" % zippedfile

zip = zipfile.ZipFile(zippedfile,'r')

filesList = zip.namelist()

#put the files in the folders
for k in filesList:
    if not k.endswith('/'):
        f = os.path.split(k)
        #print f
        if 'doc' in f[0]:
            file(os.path.join('doc',f[1]),'wb').write(zip.read(k))
        elif 'libws' in f[0]:
            file(os.path.join('libws',f[1]),'wb').write(zip.read(k))
        elif 'lib' in f[0]:
            file(os.path.join('lib',f[1]),'wb').write(zip.read(k))
        else:
            file(f[-1],'wb').write(zip.read(k))

# apply patches
if os.name == 'posix':
    os.system('patch -p1 < jsolait.patch')
    print "done."
else:
    print dedent('''\
        All files are downloaded and extracted. However, you yet
        need to manually apply the patches from jsolait/jsolait.patch.

        i.e. on a posix system that would be:

            cd jsolait
            patch -p1 < jsolait.patch

        ''')

print
print "original zip file is %s" % zippedfile
